// Timer 1B base address
#define		TM_BASE					0x40031000

// Peripheral clock enabling for timer and GPIO
#define		RCGC_TIMER_R			(*((volatile unsigned long *)0x400FE604))
#define		RCGC2_GPIO_R			(*((volatile unsigned long *)0x400FE108))
#define		CLOCK_GPIOB				0x00000002
#define		SYS_CLOCK_FREQUENCY		16000000


// General purpose timer register definitions
#define		GPTM_CONFIG_R			(*(volatile unsigned long *)(TM_BASE + 0x000))
#define		GPTM_TB_MODE_R			(*(volatile unsigned long *)(TM_BASE + 0x008))
#define		GPTM_CONTROL_R			(*(volatile unsigned long *)(TM_BASE + 0x00C))
#define		GPTM_INT_MASK_R			(*(volatile unsigned long *)(TM_BASE + 0x018))
#define		GPTM_INT_CLEAR_R		(*(volatile unsigned long *)(TM_BASE + 0x024))
#define		GPTM_TB_IL_R			(*(volatile unsigned long *)(TM_BASE + 0x02C))//Timer1B
#define		GPTM_TB_MATCH_R			(*(volatile unsigned long *)(TM_BASE + 0x034))
#define		GPTM_TB_PRESCALE_R		(*(volatile unsigned long *)(TM_BASE + 0x03C))
#define		GPTM_TB_PRESCALE_MATCH_R	(*(volatile unsigned long *)(TM_BASE + 0x044))
#define 	GPTM_TB_R				(*(volatile unsigned long *)(TM_BASE + 0x04C))

// GPIO alternate function configuration
#define		GPIO_PORTB5_AFSEL_R		(*((volatile unsigned long *)0x40005420))
#define		GPIO_PORTB5_PCTL_R		(*((volatile unsigned long *)0x4000552C))//b5
#define		GPIO_PORTB5_DEN_R		(*((volatile unsigned long *)0x4000551C))
#define		GPIO_PORTB5_DIR_R		(*((volatile unsigned long *)0x40005400))

// Timer config and mode bit field definitions
#define		TIMER1_CLK_EN			0x00000002
#define		TIM_16_BIT_CONFIG		0x00000004	// individual timer mode
#define		TIM_PERIODIC_MODE		0x00000002	// Periodic timer mode
#define		TIM_B_EN				0x00000100	// Timer A enable control
#define		TIM_CAPTURE_MODE		0x00000004	// ~(edge-count)/(edge-time) mode (clear it for PWM)
#define		TIM_PWM_MODE			0x0000000A

//	Timer1 A reload value for 50 Hz PWM frequency
#define		TIM_A_INTERVAL			57855				// Timer reload value for 50 Hz PWM frequency at clock frequency of 16 MHz
														// with prescale factor 4, as 16,000,000/5/64000 = 50 Hz
//#define		TIM_A_MATCH				41855				// Timer match value for about 5% duty cycle
#define		PRESCALE_FACTOR			4					// For changing the timer's input frequency to 16e6/5


//#define TIM_A_MATCH_2ms  25855  // for 2ms dutycycle

//Functions Definations
void Clock_Init_portB5_timer(void);
void PortB5_Init(void);
void TimerDisableGREEN(void);
void TimerTYPEGREEN(void);
void TimerEnableGRREN(void);
//void SystemInit(void);
//void delay(unsigned long i);
void GREENSERVO(int PRESCALE);
