
/*

INTRODUCTION:
     This is the main file of the program. The purpose of this code to 
		 run the hardware system of conveyer belt based color sorter. The 
		 sensors used in this hardware are obstacle sensor and color sensor.
		 In the main file, All the registers related to color sensor, obstacle
		 sensor and system configuration related settings. 
		 
HARDWARE:
     The hardware system contains an obstacle sensor, a color sensor, 
		 three servo motors of color red,blue and green. A conveyer belt 
		 which is run on the gears by the 12V, 1A DC geared 40 RPM motor. 
		 
WORKING:
     The software code is written in such a way that it optimized with hardware. 
		 Three arms of different colors are connected with three different servo 
		 motors. A conveyer belt is running which is waiting for a coloured object.
		 In the main function, a while code is running which means it is waiting for 
		 interrupt by obstacle sensor. When an object passes then obstacle sensor sense
		 it and call for interrupt, In the ISR function, the motors is stopped by relays. 
		 and colour sensor starts judging the colour, on the basis of frequency, it decides
		 that which servo has to start. For example, if red object passes then in the 
		 ISR, the red servo motor pwm function will be called and after some delay, the
		 motor arm will be back in the position and that cycle repeats infinitely. 
		 
CREDITs:
   
	 Students
     Muhammad Ahmad Khalid B.Sc EE(UET Lahore)
		 Muhammad Abdullah Ahmad B.Sc EE (UET Lahore)
		 Jawad Afridi         B.Sc EE (UET Lahore)
		 Faizan Obaid Kashmiri B.Sc EE (UET Lahore)
		 
	 Instructors
	    Sir. Umer Shahid M.Sc EE (UOL Lahore)
			Dr. Kashif Javed Associate Professor (UET Lahore)
		 
		 
		 
		 */
		 


#include "main.h"


int main(){
	
			Init_INT_GPIO();

	while(1){
		
		GPIO_PORTA_DATA_R = 0x00;
		
}
		WaitForInterrupt();	
}

void GPIOPortF_Handler(void)
{
	  
		GPIO_PORTA_DATA_R = 0x80; // relay off
	  delay(10000000); //waiting so object can reach exactly under the colour sensor and wait for response by color sensor
	
	
	
	/*  =========================================================
                    CODE LINES FOR GREEN OBJECTS
      =========================================================

*/
	
	if(  frequency ==570){
		

	  Clock_Init_portB5_timer(); 
	  PortB5_Init();            //Initializing the Port B timers
	
	  GREENSERVO(41855);   //Rotate the green servo arm 
		
	  delay(10000000);     //Delay for object sorting
		
		GREENSERVO(22855); //Rotate now green servo arm in opposite direction. Back to the original position
		
	  delay(10000000);      //Delay for object sorting  
	
	}//endif
	
		//Timer2A_Init();
	
	/*  =========================================================
                    CODE LINES FOR BLUE OBJECTS
      =========================================================
*/
	
	
		if(   frequency >600 && frequency < 700){
			
 Clock_Init_portB_timer();// apply clock to port f and timer 1A
			
 PortB_Init(); // Select afsel , DIR , PORT CONTROL FOR PF2
			
	delay(10000000);  //Additional delay according to the hardware settings
			
	BLUESERVO(41855);   //Calling Blue Servo function for rotate the arm
			 
	delay(10000000); 
			
	BLUESERVO(22855);  //Calling blue servo function for rotate back to the original position
			
	delay(100000);
			
		}//endif
		
		/*  =========================================================
                    CODE LINES FOR RED OBJECTS
        =========================================================

*/
		if(  frequency > 800){
			GPIO_PORTA_DATA_R = 0;
	Clock_Init_portf_timer();
			
Portf_Init();
			
	delay(10000000);  //delay according to the hardware settings
			
	REDSERVO(22855);  //Calling red servo function to rotate the servo arm for red objects 
			
	delay(10000000);
			
	REDSERVO(41855); //Rotating back to the position
			
	delay(10000000);
					
		}//endif
	
}//end ISR function

void delay (unsigned long value){
   int i;
	for (i = 0; i < value; i++){
	}
}//end delay

void DATA_zero (void){
	GPIO_PORTA_DATA_R = 0;
	
}//end DATA_zero

void Init_INT_GPIO(void){

	volatile unsigned delay_clk;

	SYSCTL_RCGCGPIO_R |= PORTFA_CLK_EN;   //Enable clock for PORTF and portA
	delay_clk = SYSCTL_RCGCGPIO_R;  //dummy read to stable the clock

	//GPIO
	GPIO_PORTF3_DEN_R |=  0x08  ;  //0x1F; //Enable digital Input on PF3 
	GPIO_PORTF3_DIR_R  |= 0x00 ; //______________; //Make PF3 input for obstacle sensor


	
// For port A RELAY SIGNAL TO IN2
	
	GPIO_PORTA_DEN_R = 0x80; // enable digitaly pA7
	GPIO_PORTA_DIR_R  = 0x80 ; // make pA7 an output
	
	//INTERRUPT
		DisableInterrupts();
	GPIO_PORTF_IS_R = INT_PF3; //PF3 is level sensitive
	//GPIO_PORTF_IBE_R &= ~INT_PF4; //PF4 is not both edges
	GPIO_PORTF_IEV_R = 0x00;   // &= ~INT_PF3; //PF3 is low level 
	//
	GPIO_PORTF_IM_R  = INT_PF3;  //Enable interrupt on PF3


	NVIC_PRI7_R =  0x00000000;  //__________________; //Set PF3 priority  5
	NVIC_EN0_R = NVIC_EN0_INT30;   //Enable interrupt 30 in NVIC
EnableInterrupts();

}//end INIT function
