/*    =========================================================
                               HEADERS
      =========================================================

*/

   #include <stdio.h>
	 #include "green_motor.h"
	 #include "blue_motor.h"
	 #include "red_motor.h"

/*    =========================================================
                       DEFINITION OF REGISTERS
      =========================================================

*/

#define SYSCTL_RCGCGPIO_R  (*(( volatile unsigned long *) 0x400FE608 )) // IRQ 0 to 31 Set Enable Register

#define NVIC_EN0_R         (*(( volatile unsigned long *) 0xE000E100 )) // IRQ 0 to 31 Set Enable Register

#define NVIC_PRI7_R         (*(( volatile unsigned long *) 0xE000E41C )) //Interrupt Priority Register

//for portf3 which is acting as an input for obstacle sensor
#define GPIO_PORTF3_DATA_R  (*(( volatile unsigned long *) 0x4002503FC ))
#define GPIO_PORTF3_DIR_R  (*(( volatile unsigned long *) 0x40025400 ))
#define GPIO_PORTF3_DEN_R  (*(( volatile unsigned long *) 0x4002551C ))


//For portA7 which is acting as an output to relay
#define GPIO_PORTA_DATA_R  (*(( volatile unsigned long *) 0x400043FC ))
#define GPIO_PORTA_DIR_R  (*(( volatile unsigned long *) 0x40004400 ))
#define GPIO_PORTA_DEN_R  (*(( volatile unsigned long *) 0x4000451C ))

//Interrupt type for port F3
#define GPIO_PORTF_IS_R  (*(( volatile unsigned long *) 0x40025404 ))
#define GPIO_PORTF_IEV_R  (*(( volatile unsigned long *) 0x4002540C )) // low level sensitive
#define GPIO_PORTF_IM_R  (*(( volatile unsigned long *) 0x40025410 ))
#define GPIO_PORTF_IC_R  (*(( volatile unsigned long *) 0x4002541C ))



#define NVIC_EN0_INT30   0x40000000     //interrupt 30 enable
#define PORTFA_CLK_EN      0x21        //CLock enable for Port f AND PORT E
#define INT_PF3    0x08                //interrupt at PF3



/*    =========================================================
                         FUNCTION PROTOTYPES
      =========================================================

*/



void EnableInterrupts (void){}  //Enable Interrupts
void DisableInterrupts (void){}  //Disable Interrupts
void Init_INT_GPIO (void);    //Initialize GPIO and Interrupts
void delay (unsigned long value);  //impelements delay
void WaitForInterrupt (void) ; //Waiting for interrupts
void DATA_zero (void);

int frequency = 5700;  //Colour sensor initial frequency